//#########################################################################
// File: kcfile.c  /  KC Serial Compactflash Firmware 0.02
//
// Most stuff is taken from Holger Klabunde/Arne Fitzenreiter
//#########################################################################
// Processor: ATMega32
//#########################################################################
// Compiler: WinAVR
//#########################################################################
// edit by Kingstener 2007/2012/2013 for KC87
//#########################################################################
#include <string.h>
#include "mydefs.h"
#include "printf.h"
#include "serial.h"
#include "dos.h"
#include "pport.h"
#include "commands.h"
unsigned char printfmode; //0-serial,1-lcd,2both
unsigned char echo; //echo to pp 0=off
unsigned char line[130];     //Zeichenpuffer
//########################################################
unsigned long htoul(char *s)//ASCII->Hex
//########################################################
{
 unsigned char c,i;
 unsigned long tmp=0;
 for(i=0;i<4;i++)
  {
   c=*s++;
   if(c>='0' && c<='9'){tmp*=16;tmp+=c-'0';}
   if(c>='A' && c<='F'){tmp*=16;tmp+=10+c-'A';}
  }
  return tmp;
}

//########################################################
void KCsave(char *FileName)//speichert KC-File auf CF als KC-Tapefile
//########################################################
{
	unsigned int i; 
	unsigned char smode;
	unsigned int aadr;
	unsigned int eadr;
	unsigned int sadr;
	unsigned int l;
	unsigned char block;
	char nametmp[12];

	if ((strlen(FileName)>15)&&(strlen(FileName)<28))
	{
		aadr=htoul(&FileName[0]);
		eadr=htoul(&FileName[5]);
		sadr=htoul(&FileName[10]);
//########## 8.3 Namen ins Kc Format umstapeln ###########
		l=0;
		for (i=0;i<11;i++) nametmp[i]=' ';
		for (i=0;i<12;i++)
		{
			if (FileName[15+i]=='.') l=8;//Erweiterung ans Ende bei Name <8
			else{nametmp[l]=FileName[15+i];l++;}
			if (l>10) i=20;
		}
//########################################################
		if(FindName(&FileName[15])==FULL_MATCH)//Ueberschreibschutz
		{printf("\nFile exists");
		return;
		}
		printf("\nSave %04x %04x %04x %s ...",aadr,eadr,sadr,&FileName[15]);

		if(Fopen(&FileName[15],F_WRITE))
		{
			strcpy((char*)line,"\xC3KC-TAPE by AF. \x0");
			Fwrite(line,17); //Tapeheader + Blocknr
			for (i=0;i<130;i++) line[i]=0;//Leerblock erzeugen
			if (sadr==0xffff) smode=2;else smode=3;//Autostart nein/ja
			strcpy((char*)line,nametmp);
			line[16]=smode;
			line[17]=aadr; line[18]=aadr>>8;
			line[19]=eadr; line[20]=eadr>>8;
			if (smode==3)
			{
				line[21]=sadr; line[22]=sadr>>8;
			}
			Fwrite(line,128); //Block 1 schreiben
			l=eadr-aadr+1;
			ser_putc(0x1b); //Special mode
			ser_putc(0x56); //download code
			ser_putc(aadr); //start address
			ser_putc(aadr>>8);
			ser_putc((l));   //l�nge
			ser_putc((l)>>8);
			for (i=0;i<130;i++) line[i]=0;
			block=0; i=0;
			while (l>0)
			{
				i++;
				line[i]=getp();
				l--;
				if (i>127) 
				{
					block++;
					line[0]=block;//Blocknummer
					Fwrite(line,129); //Datenblock
					for (i=0;i<130;i++) line[i]=0;
					i=0;
			
				}
			}
			line[0]=0xFF;
			Fwrite(line,129); //Letzer Block
			printf("\ndone");
			Fclose();
		}
		else 
		{
		printf("\nCannot open File!");
		}
	}	
	else
	{
	printf("\nSyntax!");// zu viel oder zu wenig eingegeben
	}
}
//########################################################
void KCload(char *FileName)//laedt KC-Tapefile von SD in den KC
//########################################################
{
	unsigned char counter; //Bytez�hler
	unsigned int i,b,rest;
	unsigned int aadr;
	unsigned int eadr;
	unsigned int sadr;
 	unsigned int l;
 
 	if(Fopen(FileName,F_READ))
	{
		printf("\nLoad %s ",FileName);
		counter=Fread(line,16);  //header lesen
	  	if(strncmp((char*)line,"\xC3KC-TAPE",8)==0)//check auf .tap-Format
		{
		counter=Fread(line,129);   //1. Block
		if((line[0] ==1)&&((strncmp((char*)&line[1],"\xD3\xD3\xD3",3)==0)||(strncmp((char*)&line[1],"\xD7\xD7\xD7",3)==0)))
			//BASIC sollte mit Block1 und 3x D3 oder D7 beginnen
			{
			l=(line[12]&0xFF)+(line[13]<<8);b=1;rest=14;//Laenge, 129/Block,Rest 1.Block
			goto bas; //-> zur Laderoutine Basic
			}
		else if((line[0] ==0)&&(((line[17])==2)||((line[17])==3)))	//Maschinenprogramme sollten mit Block 0 beginnen
				{													// und smode 2 der 3 haben
				aadr=(line[18]&0xFF)+(line[19]<<8);
				eadr=(line[20]&0xFF)+(line[21]<<8);
				sadr=(line[22]&0xFF)+(line[23]<<8);
				printf("%04x %04x %04x ...",aadr,eadr,sadr);
				if (eadr>=EOR()){printf("!>EOR!");l=1;eadr=aadr;} //Ueberschreibschutz
				l=eadr-aadr+1;
		 		ser_putc(0x1b); //Special mode
				ser_putc(0x54); //upload code
				ser_putc(aadr); //start address
				ser_putc(aadr>>8);
				ser_putc((l));   //l�nge
				ser_putc((l)>>8);
				while((counter=Fread(line,129))) //block einlesen solange vorhanden
				{
					for(i=1; i<counter; i++)
					{
						if (l>=1){ser_putc(line[i]);l--;}
					}
				}
				if (eadr>aadr)printf("\ndone");
		  	}
			else
			{		
				printf("- bad Header");
			} 

		}
	  	else printf("- no TAP");
	  	if((strstr(FileName,"SSS")))
	  	{
	  	l=(line[0]&0xFF)+(line[1]<<8);//Laenge
	  	if(FileSize==(l+3))//BASICfiles ohne Header
			{				  // check Laenge= Filelaenge-2 (dirty..!)
	  		printf("\nTestLoad ");
	  		b=0;rest=2;// 129/Block,Rest 1.Block
				bas://Laderoutine Basic
					aadr=0x0401;
					eadr=aadr+l;
					printf("%04x %04x",aadr,eadr);
					printf(" <BASIC>");
					if (eadr>=EOR()){printf("!>EOR!");l=1;eadr=aadr;} //�berschreibschutz
					l=l+1;
					ser_putc(0x1b); //Special mode
					ser_putc(0x54); //upload code
					ser_putc(aadr); //start address
					ser_putc(aadr>>8);
					ser_putc((l));   //l�nge
					ser_putc((l)>>8);
					for(i=rest; i<counter; i++)//rest block
						{
							if (l>=1){ser_putc(line[i]);l--;}
						}
					while((counter=Fread(line,129))) //next block,  solange vorhanden
					{
						for(i=b; i<counter; i++)
							{
								if (l>=1){ser_putc(line[i]);l--;}
							}
					}
					ser_putc(0x1b); //Special mode
					ser_putc(0x54); //upload code
					ser_putc(0xd7); //start address
					ser_putc(0x03);
					ser_putc(6);   //l�nge
					ser_putc(0);
					for (i=0;i<3;i++)
						{
							ser_putc(eadr); //Endadresse eintragen, Variablen l�schen
							ser_putc(eadr>>8);
						}
					if (eadr>aadr)printf("\ndone");
			}
	  	}
	}
    else printf("\nFile not found");
	Fclose();
}
//########################################################
void rawload(char *FileName)//laedt File von SD in den KC
// inp: Adresse + Name, Länge = Filelänge
//########################################################
{
	unsigned int aadr;
	unsigned int eadr;
	unsigned int l;
 	if(Fopen(&FileName[5],F_READ))
	{
		printf("\nLoad %s ",FileName[5]);
		aadr=htoul(&FileName[0]);
		l=Filelength();
		eadr=aadr+l;
		printf("%04x %04x...",aadr,eadr-1);
		ser_putc(0x1b); //Special mode
		ser_putc(0x54); //upload code
		ser_putc(aadr); //start address
		ser_putc(aadr>>8);
		ser_putc((l));   //Länge
		ser_putc((l)>>8);
		while(l) // einlesen solange Vorrat
		{
			Fread(line,1);//von Karte
			ser_putc(line[0]);l--;//zum KC
		}
		if (eadr>aadr)printf("\ndone");
	}
	else printf("\nFile not found");
	Fclose();
}
//########################################################
void rawsave(char *FileName)//speichert File auf CF
//inp: Anfangs-, Endadresse + Name
//########################################################
{
	unsigned int aadr;
	unsigned int eadr;
	unsigned int l;
	if ((strlen(FileName)>10)&&(strlen(FileName)<23))
	{
		aadr=htoul(&FileName[0]);
		eadr=htoul(&FileName[5]);
		if(FindName(&FileName[10])==FULL_MATCH)//Ueberschreibschutz
			{printf("\nFile exists");
			return;
			}
		printf("\nSave %04x %04x %s ...",aadr,eadr,&FileName[10]);
		if(Fopen(&FileName[10],F_WRITE))
		{
			l=(eadr-aadr)+1;
			ser_putc(0x1b); //Special mode
			ser_putc(0x56); //download code
			ser_putc(aadr); //start address
			ser_putc(aadr>>8);
			ser_putc((l));   //länge
			ser_putc((l)>>8);
			while (l)		//solange Vorrat
				{
					line[0]=getp();l--;//vom KC
					Fwrite(line,1);	//auf Karte
				}
			printf("\ndone");
			Fclose();
		}
	}
	else
		{
		printf("\nSyntax!");// zu viel oder zu wenig eingegeben
		}
}
//########################################################
void memo(char *adr)//nutze hier "line" mit
// gibt 8byte Block eines Files oder
// RAM ab AAAA als hex/ascii aus
// Enter weiter stop+Enter Stop
//########################################################
  {
	unsigned int l,aadr=0;
	int z;
	if(Fopen(adr,F_READ))//wenn file vorhanden
	 {
		z=Fread(line,8);//erste 8 Bytes
		do
		{
		printf("\n%04x ",aadr);//Adresse
		for (l=0;l<8;l++){z--;if(z>=0){ser_puthex(line[l]);}else{printf("  ");line[l]=0;}printf(" ");}//HEX
		for (l=0;l<(8);l++) {if((line[l]>0x1F) && (line[l] <0x7f)) ser_putc(line[l]);//ASCII
		else printf(".");}
		aadr+=8;ser_putc(0x80);
		}
		while((!Command())&&(z=Fread(line,8)));//weitere 8 Bytes Enter stop mit Stop+Enter oder Fileende
		Fclose();
	 }
	else//sonst Speicher
	 {
		aadr=htoul(&adr[0]);
		do
			{
			ser_putc(0x1b); //Special mode
			ser_putc(0x56); //download code
			ser_putc(aadr); //start address
			ser_putc(aadr>>8);
			ser_putc(0x09);
			ser_putc(0x00);
			for (l=1;l<10;l++) {line[l]=getp();}//RAM-Inhalt holen
			printf("\n%04x ",aadr);//Adresse
			for (l=1;l<9;l++) {ser_puthex(line[l]);printf(" ");}//HEX
			for (l=1;l<9;l++) {if((line[l]>0x1F) && (line[l] <0x7f)) ser_putc(line[l]);//ASCII
			else printf(".");}
			aadr+=8;ser_putc(0x80);
			}
		while(!Command());//weiter Enter stop mit Stop+Enter
	}
  }
//########################################################
void jump(char *adr)  //Programm starten
//########################################################
  {
	unsigned int sadr;
	sadr=htoul(&adr[0]);
	ser_putc(0x1b); //Special mode
	ser_putc(0x55); //run code
	ser_putc(sadr);
	ser_putc(sadr>>8);
  }
