//#########################################################################
// File: kcscf.c  /  KC Serial Compactflash Firmware 
//
// Most stuff is taken from Holger Klabunde/Arne Fitzenreiter
//#########################################################################
// Last change: 30.11.2007/02-2013
//#########################################################################
// edit by Kingstener
//#########################################################################
// Processor: ATMega32
//#########################################################################
// Compiler: WinAVR
//#########################################################################

#include <avr/io.h>
#include <avr/interrupt.h>
#include "mydefs.h"
#include "printf.h"
#include "serial.h"
#include "dos.h"
#include "commands.h"
#include "tape.h"
#include "kcfile.h"
#include "fat.h"
unsigned char printfmode; //0-serial,1-lcd,2both
unsigned char echo; //echo back serial input 0=off
typedef struct
	{
	unsigned long dev_id;
	unsigned short app_version;
	unsigned short crc;
	} bootldrinfo_t;
//Kennung für Bootloader bei0x77f8  dev_id="x8CK" , Version  crc mit crcgen auffüllen(n.B.)
const bootldrinfo_t bootlodrinfo __attribute__ ((section (".bootloader"))) = {0x3738434B, 0x0013, 0x0000};
typedef struct
	{
	unsigned short cod;
	}
	corr_t;
// rjmp +2046 bei 7000h	Korrektur Sprung zum Bootloder wg. Fusefehler High D8 statt DA, falsche Startadresse
const corr_t corr __attribute__ ((section (".corr"))) = {0xc3ff};



//###################################################################################
//* Hauptprogramm */ evtl. dosdefs.h anpassen!!!
//###################################################################################
int main(void)
{
	unsigned char c;
	DDRC=0xFF;  	// set io-pins on PortC
	PORTC=0xff; 	//n.b.
	DDRD=0xc0; 		//Alles Eingänge, 6+7 ausg
	PORTD=0xFF; 	//Eingänge mit Pullups setzen
	sei();          //enable interrupts
	echo=0;			// Ausgabe Info unterdrücken
	GREEN_ON();
	MMC_IO_Init();					//Karte initialisieren
	if(GetDriveInformation()!=F_OK) // get drive parameters
	{
		GREEN_OFF();
		echo=1;
		printf("SD-Karte nicht erkannt!\n");
		while(1);	//Ende im Gelände
	}
	Upload();
	GREEN_ON();
	echo=1;//Ausgabe ein
	printf("SD-CARD-OS KC87 V1.3");
	for(;;) //for ever
	{
		printfmode=0;
	  	printf("\nSD>"); //Prompt ausgeben
		ser_putc(0x80);//Umschaltkommando
		printfmode=0; //serial
		c=WaitCommand();
		switch(c)// war mal Commandoauswahl, immer mehr nach commands verlegt
		{
			case HELP: HelpScreen(); break;
			case INFO:
			printf("\n");
			MMC_IO_Init(); GetDriveInformation();
			printf ("Size %lu kb\n",drivesize());
			printf ("Free %lu kb\n",drivefree()); break;
			case EORAM: printf("\nRAM-Ende:%04x",EOR()); break;
		}
	}
}



