//########################################################
// File: pport.c
// Parallele Portein-/ausgabe ueber PortA/D
// Datenuebertragung zum KC87-Userport
// PD0-PD3 In/Output, PD4,5 Input,PD6,7 outp
//########################################################
// 2008/2012 (c)by Kingstener
//########################################################
// Prozessor:Atmega32/328P
//########################################################
#include <string.h>
#include <avr/io.h>
#include <util/delay.h>
//########################################################
void putp (unsigned char c)  //Parallel Ausgabe
//########################################################
  {
    DDRD=0xcf; 					//Alles ausg, 4+5 eing
	PORTD=0xFF; 				//Eingaenge mit Pullups setzen
	unsigned char b=c;			//
	PORTD = ((b & 0x0f)|0xb0);	//l nibble ausgeben
	while(!((PIND & 0x30)==0x10));//auf ready=1.nibble(low) warten
	PORTD = (((c >>4)& 0x0f)|0x30);//h nibble ausgeben
	while(!((PIND & 0x30)==0x00));//auf ready=2.nibble(hi) warten
	while(!((PIND & 0x30)==0x30));//warten auf ready
	PORTD = 0xff;				//busy
  }

//########################################################
unsigned char getp (void)  //Parallel Eingabe
//########################################################
 {
	_delay_us(150);				// ohne gibts crash !??
    DDRD=0xc0; 					//Alles eing 6+7 ausg
	PORTD=0xFF; 				//Eingaenge mit Pullups setzen
	unsigned char c,b;
	PORTD &= ~(1<<PD7); 		// bit loeschen bereit fuer 1. nibble (l)
	while(!((PIND & 0x30)==0x20));//auf ready=1.nibble(low) warten
	c=PIND & 0x0f;				//Port lesen
	PORTD &= ~(1<<PD6);			//bereit fuer 2. nibble (h)
	while(!((PIND & 0x30)==0x00));//auf ready=2.nibble(lh) warten
	b=PIND & 0x0f; 				//Port lesen
	PORTD = 0xff; 				//busy
	c=c+ (b<<4);				//Byte zusammensetzen
	return (c);
 }
//########################################################
unsigned char Command(void)
// fuer Tastenabfragen innerhalb einer Kommandoabarbeitung
// muss immer mit Enter (0x0d) abgeschlossen werden
// kommt mit 0 oder einem eingegebenen Zeichen zurück
//########################################################
 {
	char c,s=0;
	do{c=getp();if(c!=0x0D) s=c;}
	while(c!=0x0d);
	return (s);
 }

  

