//#########################################################################
// File: tape.c
// Fileuebertragung (.tap mit Blocknummer) an den KC
// als Tape-Signal
//#########################################################################
// 2007/2012 (c) by Kingstener
//#########################################################################
// Processor: ATMega32/328P
//#########################################################################
#include <avr/io.h>
#include <string.h>
#include "tape.h"
#include "dos.h"
#include "mydefs.h"
void byteout(unsigned char c);
void vorton(unsigned int len);
void Delay10us(unsigned char time);
void bitl();
void bith();
void trennz();
//#########################################################################
void Upload(void)//Tape Uploader
//#########################################################################
{
	unsigned char count; //Bytezaehler
	unsigned int i,j=0,k;
	unsigned char line[130];
	if(Fopen("load87",F_READ))
    {
	count=Fread(line,16);//Vorspann ausblenden
	while((count=Fread(line,129))) //1 block lesen 
		{ 
		vorton(j);j++;k=0;//Vorton
		byteout(line[0]);//Blocknummer ausgeben
		for(i=1; i<count; i++)	
			{
			byteout(line[i]);//Datenblock
			k=k+(line[i]);//Pruefsumme bilden
			}
		byteout(k);//Pruefsumme ausgeben
		}
	Fclose();//fertig
	}
  
 }
//######################################################################### 
void byteout(unsigned char c)  //Byteausgabe
//#########################################################################
  {
	unsigned int z;	//bitzaehler
	for(z=0;z<8;z++) {  if (c & (1 << z)) {bith();} else {bitl();};} //Einzelbits auswerten
	trennz();
  }
//#########################################################################
void bitl (void)  //Ausgabe 0-Bit 2400Hz
//#########################################################################
  {
  	Delay10us(16);		// 208us
	PORTC |= (1<<PC1); // Bit setzen
	Delay10us(16);		// 208us
	PORTC &= ~(1<<PC1); // bit loeschen
  }

//#########################################################################
void bith (void)  //Ausgabe 1-Bit 1200 Hz
//#########################################################################
  {
   	Delay10us(32);		// 416us
	PORTC |= (1<<PC1); // Bit setzen
	Delay10us(32);		// 416us
	PORTC &= ~(1<<PC1); // bit loeschen
  }

//#########################################################################
void trennz (void)//1 Trennzeichen 600Hz
//#########################################################################
  {
   	Delay10us(64);		// 832us
	PORTC |= (1<<PC1); // Bit setzen
	Delay10us(64);		// 830us
	PORTC &= ~(1<<PC1); // bit loeschen
  }
  
//#########################################################################  
void vorton (unsigned int len)//vorton 8000xbith
//#########################################################################
{
 unsigned int m,n,o;
 if (len==0) {o=50;} else {o=2;}// eigentlich 8000 also 200x40,war mir zu lang
 for(m=0; m<o; m++)				// als Vorton,die else ist fuer Folgebloecke
 { 
   for(n=0; n<40; n++)
    {
     bith();
    }
  }
trennz();
}

//##########################################################################
//Nicht sonderlich genau !!
void Delay10us(unsigned char time)//ca 12,78uS beim Atmega 325P mit int. 8MHz
//##########################################################################
{
 unsigned char k,l;

 for(k=0; k<time; k++)
  {
   for(l=0; l<7; l++)
    {
     //Ein CPU-Clock = 0.07us bei 14,3MHz
     NOP(); NOP(); NOP(); NOP(); NOP();  //frequenz muss evtl. noch optimiert
     NOP(); NOP(); NOP(); NOP(); NOP();  //werden
    }
  }
}
